/*
 * shohaku
 * Copyright (C) 2005  tomoya nagatani
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package shohaku.ginkgo;

/**
 * 複数のノードとドキュメントを合成するためのルールのデフォルト実装提供します。
 */
class DefaultDocumentCompositeRule implements DocumentCompositeRule {

    /**
     * ルートノードの属性(id)の値を公開識別子として返却します。
     * 
     * @param document
     *            ドキュメント
     * @param root
     *            ルートノード
     * @return ドキュメントの公開識別子
     */
    public String getDocumentId(Document document, Node root) {
        return root.getAttribute("id");
    }

}